SystemOrganization addCategory: #'OCMS-Database'!

Object subclass: #Coursewares
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Coursewares class methodsFor: 'as yet unclassified' stamp: 'has 5/26/2013 11:59'!
add: aCourseware
	aCourseware id: self incrementId.
	OCMSDB commit: [self database add: aCourseware].! !

!Coursewares class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 20:15'!
database
	^ OCMSDB root at: 'coursewares'.! !

!Coursewares class methodsFor: 'as yet unclassified' stamp: 'has 5/26/2013 17:21'!
getAll
	| reader |
	reader := self database where: [:each | each id > 0].
	^ reader.! !

!Coursewares class methodsFor: 'as yet unclassified' stamp: 'has 5/26/2013 11:45'!
incrementId
	| maxCourseware newId |
	newId = 0.
	(self database size > 0)
		ifTrue: [	maxCourseware := self database detectMax: #id.
				newId := maxCourseware id + 1]
		ifFalse: [newId = 1].
	^ newId.! !

!Coursewares class methodsFor: 'as yet unclassified' stamp: 'has 5/26/2013 18:08'!
remove: aCourseware
	(self database includes: aCourseware)
		ifTrue:[OCMSDB commit: [self database remove: aCourseware]	]
		ifFalse:[self error: 'This courseware does not exist'].! !

!Coursewares class methodsFor: 'as yet unclassified' stamp: 'has 6/2/2013 10:19'!
searchById: anId
	"return a courseware with the id or nil"
	
	| reader |
	reader := self database where: [:each | each id = anId].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!Coursewares class methodsFor: 'as yet unclassified' stamp: 'has 5/26/2013 17:07'!
searchByTitle: aTitle
	| reader |
	reader := self database where: [:each | each title from: aTitle to: aTitle maAlphabeticalNext].
	^ reader.! !

!Coursewares class methodsFor: 'as yet unclassified' stamp: 'has 5/26/2013 17:51'!
update: aCourseware
	(self database includes: aCourseware)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aCourseware.
					self database add: aCourseware].
				]
		ifFalse:[self error: 'This courseware does not exist'].! !

Object subclass: #OCMSDB
	instanceVariableNames: 'session'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OCMS-Database'!

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:52'!
commit: anDBOperation
	self default session commit: anDBOperation! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:15'!
default
	^ Default ifNil: [Default := self new connect; yourself].! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 20:33'!
release
	Default ifNil: [
		Default session disconnectAndClose.
		Default := nil.
		]! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:22'!
root
	^ self session root! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:20'!
session
	^ self default session! !

!OCMSDB methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:18'!
connect
	session := (MagmaRemoteLocation
				host: 'localhost'
				port: 51001) newSession.
	session connectAs: 'higor'.! !

!OCMSDB methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:19'!
session
	^ session! !
